entity nc is
	port (CleanSpeech, RefNoise: in real;
		SpeechOut: out real);
end nc;

architecture nc_beh of nc is
begin
	process (CleanSpeech, RefNoise)
		variable h0, h1, h2, h3, h4, h5, h6, h7: real;
		variable h0_1, h1_1, h2_1, h3_1, h4_1, h5_1, h6_1, h7_1: real;
		variable SpeechOut_1: real;
		variable SpeechOut0: real;
		variable RefNoise_1, RefNoise_2: real;
		variable RefNoise_3, RefNoise_4: real;
		variable RefNoise_5, RefNoise_6: real;
		variable RefNoise_7, RefNoise_8: real;
		variable Noise, NoisySpeech, ApproxNoise: real;
	begin
		Noise := 0.4 * RefNoise + 
				 0.1 * RefNoise_1 +
				 (-0.3) * RefNoise_2 +
				 (-0.2) * RefNoise_3 +
				 (0.1) * RefNoise_4 +
				 (-0.4) * RefNoise_5 +
				 0.3 * RefNoise_6 +
				 (-0.2) * RefNoise_7;
		NoisySpeech := CleanSpeech + Noise;

		h0 := h0_1 + SpeechOut_1*RefNoise_1*(0.0001220703125);
		h1 := h1_1 + SpeechOut_1*RefNoise_2*(0.0001220703125);
		h2 := h2_1 + SpeechOut_1*RefNoise_3*(0.0001220703125);
		h3 := h3_1 + SpeechOut_1*RefNoise_4*(0.0001220703125);
		h4 := h4_1 + SpeechOut_1*RefNoise_5*(0.0001220703125);
		h5 := h5_1 + SpeechOut_1*RefNoise_6*(0.0001220703125);
		h6 := h6_1 + SpeechOut_1*RefNoise_7*(0.0001220703125);
		h7 := h7_1 + SpeechOut_1*RefNoise_8*(0.0001220703125);

		h0_1 := h0;
		h1_1 := h1;
		h2_1 := h2;
		h3_1 := h3;
		h4_1 := h4;
		h5_1 := h5;
		h6_1 := h6;
		h7_1 := h7;

		ApproxNoise := h0*RefNoise +
					  h1*RefNoise_1 +
					  h2*RefNoise_2 +
					  h3*RefNoise_3 +
					  h4*RefNoise_4 +
					  h5*RefNoise_5 +
					  h6*RefNoise_6 +
					  h7*RefNoise_7;
		
		SpeechOut0 := NoisySpeech - ApproxNoise;
		SpeechOut <= SpeechOut0;
		SpeechOut_1 := SpeechOut0;
		RefNoise_8 := RefNoise_7;
		RefNoise_7 := RefNoise_6;
		RefNoise_6 := RefNoise_5;
		RefNoise_5 := RefNoise_4;
		RefNoise_4 := RefNoise_3;
		RefNoise_3 := RefNoise_2;
		RefNoise_2 := RefNoise_1;
		RefNoise_1 := RefNoise;
	end process;
end nc_beh;

configuration cfg_nc of nc is
	for nc_beh
	end for;
end cfg_nc;
