entity wdf7 is
	port(inp: in real;
	     outp: out real);
end wdf7;

architecture wdf7_beh of wdf7 is
	procedure adapt1(in1, in2, gamma: in real; out1, out2: out real) is
	begin
		out2 := in1 * (1.0 - gamma) - in2 * gamma;
		out1 := in1 * gamma + in2 * (1.0 + gamma);
	end adapt1;

	procedure adapt2(in1, in2, gamma: in real; out1, out2: out real) is
		variable t1: real;
	begin
		t1 := in2 * (gamma - 1.0) - in1 * gamma;
		out1 := in1 + t1 - in2;
		out2 := t1;
	end adapt2;
begin
	process (inp)
		variable but1, but2: real;
		variable state1, state1_1, state1_2: real;
		variable state2, state2_1, state2_2: real;
		variable state3, state3_1, state3_2: real;
		variable state4, state4_1, state4_2: real;
		variable state5, state5_1, state5_2: real;
		variable state6, state6_1, state6_2: real;
		--variable state7, state7_1, state7_2: real;
		variable n1, n2, n3, n4, n5, n6, n6_1: real;
	begin
		but1 := inp;
		but2 := inp;
		--adapt1(but1, state1_2, 0.070579, n1, state1);
		--adapt1(n1, state2_2, 0.459054, n2, state2);
		--adapt2(n2, state3_2, 0.1925556, n3, state3);
		--adapt1(but2, state4_2, 0.2474406, n4, state4);
		--adapt2(n4, state5_2, 0.3485903, n5, state5);
		--adapt2(n5, state6_2, 0.0626826, n6, state6);

		state1 := but1 * (1.0 - 0.070579) - state1_2 * 0.070579;
		n1 := but1 * 0.070579 + state1_2 * (1.0 + 0.070579);

		state2 := n1 * (1.0 - 0.459054) - state2_2 * 0.459054;
		n2 := n1 * 0.459054 + state2_2 * (1.0 + 0.459054);

		state3 := state3_2 * (0.1925556 - 1.0) - n2 * 0.1925556;
		n3 := n2 + state3 - state3_2;

		state4 := but2 * (1.0 - 0.2474406) - state4_2 * 0.2474406;
		n4 := but2 * 0.2474406 + state4_2 * (1.0 + 0.2474406);

		state5 := state5_2 * (0.3485903 - 1.0) - n4 * 0.3485903;
		n5 := n4 + state5 - state5_2;

		state6 := state6_2 * (0.0626826 - 1.0) - n5 * 0.0626826;
		n6 := n5 + state6 - state6_2;

		outp <= 0.5 * (n6_1 + n3);

		state1_2 := state1_1;
		state1_1 := state1;
		state2_2 := state2_1;
		state2_1 := state2;
		state3_2 := state3_1;
		state3_1 := state3;
		state4_2 := state4_1;
		state4_1 := state4;
		state5_2 := state5_1;
		state5_1 := state5;
		state6_2 := state6_1;
		state6_1 := state6;
		--state7_2 := state7_1;
		--state7_1 := state7;
		n6_1 := n6;
	end process;
end wdf7_beh;

configuration cfg_wdf7 of wdf7 is
	for wdf7_beh
	end for;
end cfg_wdf7;
